// FuncView.cpp : implementation of the CFuncView class
//

#include "stdafx.h"
#include "Func.h"

#include "FuncDoc.h"
#include "FuncView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CFuncView

IMPLEMENT_DYNCREATE(CFuncView, CView)

BEGIN_MESSAGE_MAP(CFuncView, CView)
    // Standard printing commands
    ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
    ON_WM_ERASEBKGND()
    ON_WM_LBUTTONUP()
    ON_WM_SIZE()
END_MESSAGE_MAP()

// CFuncView construction/destruction

CFuncView::CFuncView():
    m_RWinRect(R2Point(-12., -9.), 24., 18.),
    m_CoordOrigin(0, 400),
    m_MapX(1.),
    m_MapY(1.)
{
    // TODO: add construction code here

}

CFuncView::~CFuncView()
{
}

BOOL CFuncView::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO: Modify the Window class or styles here by modifying
    //  the CREATESTRUCT cs

    return CView::PreCreateWindow(cs);
}

// CFuncView drawing

void CFuncView::OnDraw(CDC* pDC)
{
    CFuncDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);
    if (!pDoc)
        return;

    // TODO: add draw code for native data here
    pDC->SetBkMode(TRANSPARENT);
    DrawCoordAxes(pDC, RGB(0, 0, 0), TRUE);

    CPen blackPen(PS_SOLID, 1, RGB(0, 0, 0));
    CPen redPen(PS_SOLID, 1, RGB(255, 32, 32));
    CPen bluePen(PS_SOLID, 1, RGB(32, 32, 200));

    double xmin = m_RWinRect.left();
    double xmax = m_RWinRect.right();
    double ymin = m_RWinRect.bottom();
    double ymax = m_RWinRect.top();

    CPen* oldPen = pDC->SelectObject(&redPen);
    double dx = 0.01;
    R2Point t;
    t.x = xmin;
    t.y = pDoc->f(t.x);
    pDC->MoveTo(Map(t));
    while (t.x <= xmax)
    {
        t.x += dx;
        t.y = pDoc->f(t.x);
        pDC->LineTo(Map(t));
    }

    pDC->SetTextColor(RGB(200, 10, 10));    // Red text
    CPoint p = Map(R2Point(2., 2.));
    CString txt("y = sin x");
    CSize s = pDC->GetOutputTextExtent(txt);
    pDC->DrawText(
        txt,
        CRect(p.x, p.y, p.x + s.cx, p.y + s.cy),
        DT_LEFT | DT_VCENTER
    );

    // Draw crosses in mouse clicks
    for (int i = 0; i < pDoc->m_NumPoints; ++i)
    {
        pDC->SelectObject(&bluePen);
        R2Vector dx(0.2, 0.);
        R2Vector dy(0., 0.2);

        pDC->MoveTo(Map(pDoc->m_Points[i] - dx));
        pDC->LineTo(Map(pDoc->m_Points[i] + dx));

        pDC->MoveTo(Map(pDoc->m_Points[i] - dy));
        pDC->LineTo(Map(pDoc->m_Points[i] + dy));
    }

    /* Draw triangle
    if (pDoc->m_NumPoints >= 3)
    {
        pDC->SelectObject(&redPen);
        pDC->MoveTo(Map(pDoc->m_Points[0]));
        pDC->LineTo(Map(pDoc->m_Points[1]));
        pDC->LineTo(Map(pDoc->m_Points[2]));
        pDC->LineTo(Map(pDoc->m_Points[0]));
    }
    */

    pDC->SelectObject(oldPen);
}


// CFuncView printing

BOOL CFuncView::OnPreparePrinting(CPrintInfo* pInfo)
{
    // default preparation
    return DoPreparePrinting(pInfo);
}

void CFuncView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO: add extra initialization before printing
}

void CFuncView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO: add cleanup after printing
}


// CFuncView diagnostics

#ifdef _DEBUG
void CFuncView::AssertValid() const
{
    CView::AssertValid();
}

void CFuncView::Dump(CDumpContext& dc) const
{
    CView::Dump(dc);
}

CFuncDoc* CFuncView::GetDocument() const // non-debug version is inline
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFuncDoc)));
    return (CFuncDoc*)m_pDocument;
}
#endif //_DEBUG


// CFuncView message handlers

void CFuncView::OnInitialUpdate()
{
    CView::OnInitialUpdate();

    // TODO: Add your specialized code here and/or call the base class
    CRect clientRect;
    GetClientRect(clientRect);
    m_CoordOrigin = CPoint(
        (clientRect.left + clientRect.right) / 2,
        (clientRect.top + clientRect.bottom) / 2
    );
    m_MapX = (double) clientRect.Width() / m_RWinRect.width();
    m_MapY = m_MapX;
    m_RWinRect.setHeight(clientRect.Height() / m_MapY);
    m_RWinRect.setLeft(-clientRect.Width() * 0.5 / m_MapX);
    m_RWinRect.setBottom(-clientRect.Height() * 0.5 / m_MapY);
}

BOOL CFuncView::OnEraseBkgnd(CDC* pDC)
{
    // TODO: Add your message handler code here and/or call default

    return CView::OnEraseBkgnd(pDC);
}

void CFuncView::OnLButtonUp(UINT nFlags, CPoint point)
{
    // TODO: Add your message handler code here and/or call default
    CFuncDoc* pDoc = GetDocument();
    if (pDoc->m_NumPoints >= 10)
        return;

    pDoc->m_Points[pDoc->m_NumPoints] = InvMap(point);
    ++(pDoc->m_NumPoints);
    Invalidate();

    CView::OnLButtonUp(nFlags, point);
}

CPoint CFuncView::Map(double x, double y) const
{
    return CPoint(
        m_CoordOrigin.x + (int)(x * m_MapX),
        m_CoordOrigin.y - (int)(y * m_MapY)
    );
}

R2Point CFuncView::InvMap(int x, int y) const
{
    return R2Point(
        (x - m_CoordOrigin.x) / m_MapX,
        (m_CoordOrigin.y - y) / m_MapY
    );
}

void CFuncView::OnSize(UINT nType, int cx, int cy)
{
    CView::OnSize(nType, cx, cy);

    // TODO: Add your message handler code here
    if (m_CoordOrigin.x == 0)
        return;

    CRect clientRect;
    GetClientRect(clientRect);

    // m_RWinRect(R2Point(-20., -15), 40., 30.),
    m_CoordOrigin = CPoint(
        (clientRect.left + clientRect.right)/2,
        (clientRect.top + clientRect.bottom)/2
    );

    m_RWinRect.setLeft(-clientRect.Width()*0.5 / m_MapX);
    m_RWinRect.setBottom(-clientRect.Height()*0.5 / m_MapY);
    m_RWinRect.setWidth(clientRect.Width() / m_MapX);
    m_RWinRect.setHeight(clientRect.Height() / m_MapY);
}

void CFuncView::DrawCoordAxes(
    CDC* pDC,
    COLORREF axesColor /* = 0 */,           // Black color
    BOOL bDrawGrid /* = FALSE */,
    COLORREF gridColor /* = 0x00202020 */   // Gray color
)
{
    CPen axesPen(PS_SOLID, 1, axesColor);
    CPen gridPen(PS_SOLID, 1, gridColor);
    CPen* oldPen = NULL;

    // Af first, draw a grid
    if (bDrawGrid) {
        oldPen = pDC->SelectObject(&gridPen);

        // Vertical grid
        int xmin = (int) ceil(m_RWinRect.left());
        int xmax = (int) floor(m_RWinRect.right());
        int i;
        for (i = xmin; i <= xmax; i++) {
            if (i == 0)     // y-axis
                continue;
            pDC->MoveTo(
                Map(R2Point((double) i, m_RWinRect.bottom()))
            );
            pDC->LineTo(
                Map(R2Point((double) i, m_RWinRect.top()))
            );
        }
        int ymin = (int) ceil(m_RWinRect.bottom());
        int ymax = (int) floor(m_RWinRect.top());
        for (i = ymin; i <= ymax; i++) {
            if (i == 0)     // x-axis
                continue;
            pDC->MoveTo(
                Map(R2Point(m_RWinRect.left(), (double) i))
            );
            pDC->LineTo(
                Map(R2Point(m_RWinRect.right(), (double) i))
            );
        }
    }

    // Draw axes
    CPen* oldPen1 = pDC->SelectObject(&axesPen);
    if (oldPen == NULL)
        oldPen = oldPen1;   // Remember previous pen

    // X-axis
    pDC->MoveTo(
        Map(R2Point(m_RWinRect.left(), 0.))
    );
    pDC->LineTo(
        Map(R2Point(m_RWinRect.right(), 0.))
    );

    // Y-axis
    pDC->MoveTo(
        Map(R2Point(0., m_RWinRect.bottom()))
    );
    pDC->LineTo(
        Map(R2Point(0., m_RWinRect.top()))
    );

    // Scale
    pDC->MoveTo(Map(R2Point(1., -0.1)));
    pDC->LineTo(Map(R2Point(1., 0.1)));

    pDC->MoveTo(Map(R2Point(-0.1, 1.)));
    pDC->LineTo(Map(R2Point(0.1, 1.)));

    CSize s = pDC->GetOutputTextExtent(CString("y"));
    CPoint p = Map(R2Point(0., m_RWinRect.top()));
    p.x += 4; p.y += 4;
    pDC->SetTextColor(RGB(0, 0, 0));    // Black text
    pDC->DrawText(
        CString("y"),
        CRect(p.x, p.y, p.x + s.cx, p.y + s.cy),
        DT_LEFT | DT_VCENTER
    );

    s = pDC->GetOutputTextExtent(CString("x"));
    p = Map(R2Point(m_RWinRect.right(), 0.));
    p.x -= (s.cx + 4); p.y += 4;
    pDC->DrawText(
        CString("x"),
        CRect(p.x, p.y, p.x + s.cx, p.y + s.cy),
        DT_LEFT | DT_VCENTER
    );

    pDC->SelectObject(oldPen);
}
