// FuncView.h : interface of the CFuncView class
//

#pragma once

#include "R2Graph.h"


class CFuncView : public CView
{
protected: // create from serialization only
    CFuncView();
    DECLARE_DYNCREATE(CFuncView)

// Attributes
public:
    // Mapping from double to pixel coordinates
    R2Rectangle m_RWinRect;
    CPoint m_CoordOrigin;   // Point of coordinate system origin
    double m_MapX;          // transform coefficients: double -> pixel
    double m_MapY;

    CFuncDoc* GetDocument() const;

// Operations
public:
    CPoint Map(double x, double y) const;
    CPoint Map(const R2Point& p) const
    {
        return Map(p.x, p.y);
    }
    R2Point InvMap(int x, int y) const;
    R2Point InvMap(const CPoint& p) const
    {
        return InvMap(p.x, p.y);
    }
    void DrawCoordAxes(
        CDC* pDC,                       // Pointer to device context
        COLORREF axesColor = 0,         // Color of axes: Black
        BOOL bDrawGrid = FALSE,         // Draw coordinate grid
        COLORREF gridColor = 0xd0d0d0   // Color of grid: Gray (0x00bbggrr)
    );

// Overrides
public:
    virtual void OnDraw(CDC* pDC);  // overridden to draw this view
    virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
    virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
    virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
    virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
    virtual ~CFuncView();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
    DECLARE_MESSAGE_MAP()
public:
    virtual void OnInitialUpdate();
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
    afx_msg void OnSize(UINT nType, int cx, int cy);
};

#ifndef _DEBUG  // debug version in FuncView.cpp
inline CFuncDoc* CFuncView::GetDocument() const
   { return reinterpret_cast<CFuncDoc*>(m_pDocument); }
#endif

